package info.bukova.isspst.ui.requirement;

import java.util.ArrayList;
import java.util.List;

import org.springframework.security.access.AccessDeniedException;
import org.zkoss.bind.BindUtils;
import org.zkoss.bind.annotation.Init;
import org.zkoss.zk.ui.select.annotation.WireVariable;

import info.bukova.isspst.data.TripRequirement;
import info.bukova.isspst.data.Workgroup;
import info.bukova.isspst.filters.TripRequirementFilter;
import info.bukova.isspst.services.requirement.TripRequirementService;
import info.bukova.isspst.services.users.UserService;
import info.bukova.isspst.services.workgroups.WorkgroupService;
import info.bukova.isspst.ui.ListViewModel;

public class TripRequirementListAll extends ListViewModel<TripRequirement> {
	
	@WireVariable
	private TripRequirementService tripRequirementService;
	@WireVariable
	private WorkgroupService workgroupService;
	@WireVariable
	private UserService userService;
	private List<Workgroup> allCentres;
	private List<Workgroup> allWorkgroups;

	@Init
	public void init() {
		service = tripRequirementService;
		dataClass = TripRequirement.class;
		formZul = "requirementsForm.zul";
		dataFilter = new TripRequirementFilter(getFilterTemplate());
		
		allCentres = workgroupService.getCentres();
		allWorkgroups = workgroupService.getWorkgroups();
	}

	@Override
	protected List<TripRequirement> getListFromService() {
		try {
			return tripRequirementService.getFromAll();
		} catch (AccessDeniedException e) {
			BindUtils.postGlobalCommand(null, null, "disableAll", null);
			return new ArrayList<TripRequirement>();
		}
	}

	public List<Workgroup> getAllCentres() {
		return allCentres;
	}

	public List<Workgroup> getAllWorkgroups() {
		return allWorkgroups;
	}

}
